"""
	A simple CD player for the ROX desktop.
	Copyright 2003 Ron Kuslak. <rds@rdsarts.com>
	All rights reserved.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License version 2 as
	published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""

# Could I possibly include more stuff? Seriously.
import findrox; findrox.version(1, 9, 13)
import rox, os
from roxcd_backend import RoxCd
import gobject, sys, cddb_engine, random, cd_fileio
import ripper_dialog as rip_dia
from cd_logic import cd_logic
from cd_logic.CDLow import *
from rox import g, Menu, saving
from rox.options import Option
from debug_utils import *

__builtins__._ = rox.i18n.translation(os.path.join(rox.app_dir, 'Messages'))

# 'Constants' for label text, to try and prevent breaking translations.
OK_TEXT = _('OK')
REVERT_TEXT = _('Revert')
RENAME_DIALOG_TITLE = _('Renaming track %s')
UNKNOWN_TEXT = _('(Unknown)')

class audiofile(RoxCd):
	def __init__(self):
		RoxCd.__init__(self)
		self.tracklist = []

	################################################################################################################################
	################################################################################################################################
	################## THIS IS ALL CD RIPPING STUFF! SHOULD BE CLEANED BEFORE REIMPORTING TO roxcd_backend.py!!!! ##################
	################################################################################################################################
	################################################################################################################################
	
	def get_track_info(self, track = None):
		if track == None:
			track = self.get_selected()
		track_name = self.tracklist[track]
		track += 1
		return track, track_name

	def get_cd_info(self, *dummy):
		# Get info on the currently inserted CD
		album = self.album_entry.get_text()
		artist = self.artist_entry.get_text()
		genre = self.genre.entry.get_text()
		year = int(float(self.year_range.get_value()))
		return artist, album, genre, year

	def rip_track(self, *dummy):
		# Sets us up to rip one track
		if self.get_selected() > -1:
			self.run_ripper([self.get_selected()])

	def rip_cd(self, *dummy):
		# rox.info("We're sorry, but this does not currently work.")
		# return
		tracks = []
		for x in range(0, len(self.tracklist)):
			tracks.append(x)
		self.run_ripper(tracks)

	def run_ripper(self, tracks_to_rip):
		# Sets up a savebox, and... Runs the riper... :P
		filename_regexp = self.filename.value
		dialog = None
		# if true, we are ripping the entire CD.
		rip_cd = False
		# TODO: This is unneeded. Check if we can remove for 0.6.
		extention = self.ext_name.value

		if self.cd_status == -1 or self.cd_status == 2:
			# no CD, or it's unavailable to us...
			return

		rip_list = []
		for track in tracks_to_rip:
			temp = self.get_track_info(track)
			rip_list.append([temp[0], temp[1], ''])

		# Grab a snapshot of what the state is now.
		artist, album, genre, year = self.get_cd_info()

		enc_cmd = rip_dia.fix_cmd_constants(self.encode.value, artist, album, genre, year)
		rip_cmd = rip_dia.fix_cmd_constants(self.ripper.value, artist, album, genre, year)

		filename = self.filename.value

		mime_for_save = 'audio/x-wav'
		if len(rip_list) > 1:
			# Multiple track, show directory.
			temp = []
			for track, track_name, dummy in rip_list:
				track_fixed = rip_dia.fix_cmd_track(filename + extention, track, track_name)
				track_fixed = rip_dia.fix_cmd_constants(track_fixed, artist, album, genre, year)
				temp.append([track, track_name, track_fixed])

			rip_list = temp
			rip_cd = True

			filename = self.dir_name.value
			filename = rip_dia.fix_cmd_track(self.dir_name.value, rip_list[0][0], rip_list[0][1])
			mime_for_save = 'inode/directory'
		else:
			# Single track. Closest icon to a all-purpose music DnD target :D
			filename = rip_dia.fix_cmd_track(filename + extention, rip_list[0][0], rip_list[0][1])

		filename = rip_dia.fix_cmd_constants(filename, artist, album, genre, year)
		rip_savable = rip_dia.savable(enc_cmd, rip_cmd, filename, rip_list, rip_cd)
		dialog = saving.SaveBox(rip_savable, filename, mime_for_save)
		rip_savable.set_save_box(dialog)
		dialog.show()

if __name__ == '__main__':
	try:
		g.threads_init()
	except:
		rox.croak("Sorry, but the version of PyGTK currently on your computer " +
				"does not support threading. Check with your distributors, as " +
				"they will most likely have a version available now that " +
				"supports threaded PyGTK applications.")

	main = audiofile()
	main.show_all()

	rox.mainloop()
